/* Main function.. */
#include <allegro.h>
#include <jgmod.h>
#include "main.h"
#include "engine.h"
#include "sprites.h"
#include "debug.h"
#include "menu.h"

BITMAP* buffer;
DATAFILE* sounddat;
DATAFILE* sprites;
JGMOD* music_track;
volatile int aspeed, gspeed;
volatile int last_fps, frame_counter;

void frame_control(void)
{
	aspeed++;
}
END_OF_FUNCTION(frame_control);

void fps_counter(void)
{
	last_fps=frame_counter;
	frame_counter=0;
}
END_OF_FUNCTION(fps_counter);

void init_main()
{
	srand(aspeed);
 	buffer=create_bitmap(320,240);
 	install_int_ex(frame_control, BPS_TO_TIMER(FPS));
	install_int_ex(fps_counter, BPS_TO_TIMER(1));
	aspeed=gspeed=0;

	sounddat=load_datafile("./data/sound.dat");
	sprites=load_datafile("./data/sprites.dat");
	set_pallete( (PALLETE)sprites[gamepal].dat);
	text_mode( -1 );
}

void check_parms()
{

}

int main()
{
    allegro_init();
    install_timer();
    install_keyboard();
    set_color_depth(16);
    if ( set_gfx_mode( GFX_AUTODETECT, 320, 240, 0, 0 ) < 0 )
    {
	set_color_depth(15);
    	set_gfx_mode( GFX_AUTODETECT, 320, 240, 0, 0 );		
    }
    set_trans_blender(255, 255, 255, 128);
    set_gfx_mode( GFX_AUTODETECT, 320, 240, 0, 0 );
    reserve_voices (16, -1);
    install_sound( DIGI_AUTODETECT, MIDI_NONE, NULL );
    install_mod(12);
    init_main();

    //title_menu();
    start_map( maps[0] );
  	debuglog( "Exited successfully" );

  	return 0;

}
END_OF_MAIN();

